diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/he/he-frame-exchange-manager.cc ns-3.40/src/wifi/model/he/he-frame-exchange-manager.cc
--- ns-3.39/src/wifi/model/he/he-frame-exchange-manager.cc	2023-07-05 14:23:48.113428400 -0700
+++ ns-3.40/src/wifi/model/he/he-frame-exchange-manager.cc	2023-09-27 13:30:37.906839800 -0700
@@ -116,15 +116,12 @@
 }
 
 void
-HeFrameExchangeManager::SetWifiPhy(const Ptr<WifiPhy> phy)
+HeFrameExchangeManager::RxStartIndication(WifiTxVector txVector, Time psduDuration)
 {
-    NS_LOG_FUNCTION(this << phy);
-    VhtFrameExchangeManager::SetWifiPhy(phy);
+    NS_LOG_FUNCTION(this << txVector << psduDuration.As(Time::MS));
+    VhtFrameExchangeManager::RxStartIndication(txVector, psduDuration);
     // Cancel intra-BSS NAV reset timer when receiving a frame from the PHY
-    phy->TraceConnectWithoutContext("PhyRxPayloadBegin",
-                                    Callback<void, WifiTxVector, Time>([this](WifiTxVector, Time) {
-                                        m_intraBssNavResetEvent.Cancel();
-                                    }));
+    m_intraBssNavResetEvent.Cancel();
 }
 
 void
@@ -214,26 +211,6 @@
     return false;
 }
 
-bool
-HeFrameExchangeManager::SendMpduFromBaManager(Ptr<WifiMpdu> mpdu,
-                                              Time availableTime,
-                                              bool initialFrame)
-{
-    NS_LOG_FUNCTION(this << *mpdu << availableTime << initialFrame);
-
-    // First, check if there is a Trigger Frame to be transmitted
-    if (!mpdu->GetHeader().IsTrigger())
-    {
-        // BlockAckReq are handled by the HT FEM
-        return HtFrameExchangeManager::SendMpduFromBaManager(mpdu, availableTime, initialFrame);
-    }
-
-    m_triggerFrame = mpdu;
-
-    SendPsduMap();
-    return true;
-}
-
 void
 HeFrameExchangeManager::SendPsduMapWithProtection(WifiPsduMap psduMap, WifiTxParameters& txParams)
 {
@@ -318,8 +295,7 @@
     NS_LOG_FUNCTION(this << &txParams);
 
     NS_ASSERT(txParams.m_protection && txParams.m_protection->method == WifiProtection::MU_RTS_CTS);
-    WifiMuRtsCtsProtection* protection =
-        static_cast<WifiMuRtsCtsProtection*>(txParams.m_protection.get());
+    auto protection = static_cast<WifiMuRtsCtsProtection*>(txParams.m_protection.get());
 
     NS_ASSERT(protection->muRts.IsMuRts());
     NS_ASSERT_MSG(m_apMac, "APs only can send MU-RTS TF");
@@ -386,8 +362,7 @@
     hdr.SetNoMoreFragments();
 
     NS_ASSERT(txParams.m_protection && txParams.m_protection->method == WifiProtection::MU_RTS_CTS);
-    WifiMuRtsCtsProtection* protection =
-        static_cast<WifiMuRtsCtsProtection*>(txParams.m_protection.get());
+    auto protection = static_cast<WifiMuRtsCtsProtection*>(txParams.m_protection.get());
 
     NS_ASSERT(protection->muRts.IsMuRts());
     protection->muRts.SetCsRequired(true);
@@ -420,6 +395,7 @@
     NS_ASSERT(!m_txTimer.IsRunning());
     m_txTimer.Set(WifiTxTimer::WAIT_CTS_AFTER_MU_RTS,
                   timeout,
+                  m_sentRtsTo,
                   &HeFrameExchangeManager::CtsAfterMuRtsTimeout,
                   this,
                   mpdu,
@@ -527,6 +503,23 @@
 }
 
 void
+HeFrameExchangeManager::TransmissionSucceeded()
+{
+    NS_LOG_FUNCTION(this);
+
+    // A multi-user transmission may succeed even if some stations did not respond.
+    // Remove such stations from the set of stations for which protection is not needed
+    // in the current TXOP.
+    for (const auto& address : m_txTimer.GetStasExpectedToRespond())
+    {
+        NS_LOG_DEBUG(address << " did not respond, hence it is no longer protected");
+        m_protectedStas.erase(address);
+    }
+
+    VhtFrameExchangeManager::TransmissionSucceeded();
+}
+
+void
 HeFrameExchangeManager::SendPsduMap()
 {
     NS_LOG_FUNCTION(this);
@@ -539,6 +532,7 @@
     Ptr<WifiMpdu> mpdu = nullptr;
     Ptr<WifiPsdu> psdu = nullptr;
     WifiTxVector txVector;
+    std::set<Mac48Address> staExpectResponseFrom;
 
     // Compute the type of TX timer to set depending on the acknowledgment method
 
@@ -547,7 +541,7 @@
      */
     if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE)
     {
-        WifiDlMuBarBaSequence* acknowledgment =
+        auto acknowledgment =
             static_cast<WifiDlMuBarBaSequence*>(m_txParams.m_acknowledgment.get());
 
         // schedule the transmission of required BlockAckReq frames
@@ -575,10 +569,11 @@
             timerType = WifiTxTimer::WAIT_NORMAL_ACK_AFTER_DL_MU_PPDU;
             responseTxVector =
                 &acknowledgment->stationsReplyingWithNormalAck.begin()->second.ackTxVector;
-            psdu =
-                GetPsduTo(acknowledgment->stationsReplyingWithNormalAck.begin()->first, m_psduMap);
+            auto from = acknowledgment->stationsReplyingWithNormalAck.begin()->first;
+            psdu = GetPsduTo(from, m_psduMap);
             NS_ASSERT(psdu->GetNMpdus() == 1);
             mpdu = *psdu->begin();
+            staExpectResponseFrom.insert(from);
         }
         else if (!acknowledgment->stationsReplyingWithBlockAck.empty())
         {
@@ -586,8 +581,9 @@
             timerType = WifiTxTimer::WAIT_BLOCK_ACK;
             responseTxVector =
                 &acknowledgment->stationsReplyingWithBlockAck.begin()->second.blockAckTxVector;
-            psdu =
-                GetPsduTo(acknowledgment->stationsReplyingWithBlockAck.begin()->first, m_psduMap);
+            auto from = acknowledgment->stationsReplyingWithBlockAck.begin()->first;
+            psdu = GetPsduTo(from, m_psduMap);
+            staExpectResponseFrom.insert(from);
         }
         // else no station will reply immediately
     }
@@ -596,8 +592,7 @@
      */
     else if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::DL_MU_TF_MU_BAR)
     {
-        WifiDlMuTfMuBar* acknowledgment =
-            static_cast<WifiDlMuTfMuBar*>(m_txParams.m_acknowledgment.get());
+        auto acknowledgment = static_cast<WifiDlMuTfMuBar*>(m_txParams.m_acknowledgment.get());
 
         if (!m_triggerFrame)
         {
@@ -624,18 +619,16 @@
             // set the UL Length field of the MU-BAR Trigger Frame
             m_trigVector.SetLength(acknowledgment->ulLength);
 
-            NS_ASSERT(m_edca);
-            m_edca->GetBaManager()->ScheduleMuBar(PrepareMuBar(m_trigVector, recipients));
+            m_triggerFrame = PrepareMuBar(m_trigVector, recipients);
         }
         else
         {
             // we are transmitting the MU-BAR following the DL MU PPDU after a SIFS.
             // m_psduMap and m_txParams are still the same as when the DL MU PPDU was sent.
             // record the set of stations expected to send a BlockAck frame
-            m_staExpectTbPpduFrom.clear();
             for (auto& station : acknowledgment->stationsReplyingWithBlockAck)
             {
-                m_staExpectTbPpduFrom.insert(station.first);
+                staExpectResponseFrom.insert(station.first);
             }
 
             Ptr<WifiPsdu> triggerPsdu = GetWifiPsdu(m_triggerFrame, acknowledgment->muBarTxVector);
@@ -653,11 +646,11 @@
 
             m_txTimer.Set(WifiTxTimer::WAIT_BLOCK_ACKS_IN_TB_PPDU,
                           timeout,
+                          staExpectResponseFrom,
                           &HeFrameExchangeManager::BlockAcksInTbPpduTimeout,
                           this,
                           &m_psduMap,
-                          &m_staExpectTbPpduFrom,
-                          m_staExpectTbPpduFrom.size());
+                          staExpectResponseFrom.size());
             m_channelAccessManager->NotifyAckTimeoutStartNow(timeout);
 
             ForwardPsduDown(triggerPsdu, acknowledgment->muBarTxVector);
@@ -675,18 +668,15 @@
      */
     else if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::DL_MU_AGGREGATE_TF)
     {
-        WifiDlMuAggregateTf* acknowledgment =
-            static_cast<WifiDlMuAggregateTf*>(m_txParams.m_acknowledgment.get());
-
-        // record the set of stations expected to send a BlockAck frame
-        m_staExpectTbPpduFrom.clear();
+        auto acknowledgment = static_cast<WifiDlMuAggregateTf*>(m_txParams.m_acknowledgment.get());
 
         m_trigVector =
             acknowledgment->stationsReplyingWithBlockAck.begin()->second.blockAckTxVector;
 
+        // record the set of stations expected to send a BlockAck frame
         for (auto& station : acknowledgment->stationsReplyingWithBlockAck)
         {
-            m_staExpectTbPpduFrom.insert(station.first);
+            staExpectResponseFrom.insert(station.first);
             // check that the station that is expected to send a BlockAck frame is
             // actually the receiver of a PSDU
             auto psduMapIt = std::find_if(m_psduMap.begin(),
@@ -725,15 +715,12 @@
         NS_ASSERT(IsTrigger(m_psduMap));
         mpdu = *m_psduMap.begin()->second->begin();
 
-        WifiUlMuMultiStaBa* acknowledgment =
-            static_cast<WifiUlMuMultiStaBa*>(m_txParams.m_acknowledgment.get());
+        auto acknowledgment = static_cast<WifiUlMuMultiStaBa*>(m_txParams.m_acknowledgment.get());
 
         // record the set of stations solicited by this Trigger Frame
-        m_staExpectTbPpduFrom.clear();
-
         for (const auto& station : acknowledgment->stationsReceivingMultiStaBa)
         {
-            m_staExpectTbPpduFrom.insert(station.first.first);
+            staExpectResponseFrom.insert(station.first.first);
         }
 
         // Reset stationsReceivingMultiStaBa, which will be filled as soon as
@@ -756,13 +743,11 @@
         NS_ASSERT(m_apMac);
 
         // record the set of stations solicited by this Trigger Frame
-        m_staExpectTbPpduFrom.clear();
-
         for (const auto& userInfo : trigger)
         {
             auto staIt = m_apMac->GetStaList(m_linkId).find(userInfo.GetAid12());
             NS_ASSERT(staIt != m_apMac->GetStaList(m_linkId).end());
-            m_staExpectTbPpduFrom.insert(staIt->second);
+            staExpectResponseFrom.insert(staIt->second);
         }
 
         timerType = WifiTxTimer::WAIT_QOS_NULL_AFTER_BSRP_TF;
@@ -779,10 +764,10 @@
         NS_ASSERT(m_psduMap.size() == 1);
         timerType = WifiTxTimer::WAIT_BLOCK_ACK_AFTER_TB_PPDU;
         NS_ASSERT(m_staMac && m_staMac->IsAssociated());
-        txVector = GetWifiRemoteStationManager()->GetBlockAckTxVector(
-            m_psduMap.begin()->second->GetAddr1(),
-            m_txParams.m_txVector);
+        auto recv = m_psduMap.begin()->second->GetAddr1();
+        txVector = GetWifiRemoteStationManager()->GetBlockAckTxVector(recv, m_txParams.m_txVector);
         responseTxVector = &txVector;
+        staExpectResponseFrom.insert(recv);
     }
     /*
      * QoS Null frames solicited by a BSRP Trigger Frame
@@ -827,7 +812,14 @@
 
     if (timerType == WifiTxTimer::NOT_RUNNING)
     {
-        if (!m_txParams.m_txVector.IsUlMu())
+        if (m_triggerFrame)
+        {
+            NS_LOG_DEBUG("Scheduling MU-BAR " << *m_triggerFrame);
+            Simulator::Schedule(txDuration + m_phy->GetSifs(),
+                                &HeFrameExchangeManager::SendPsduMap,
+                                this);
+        }
+        else if (!m_txParams.m_txVector.IsUlMu())
         {
             Simulator::Schedule(txDuration, &HeFrameExchangeManager::TransmissionSucceeded, this);
         }
@@ -845,6 +837,7 @@
             NS_ASSERT(mpdu);
             m_txTimer.Set(timerType,
                           timeout,
+                          staExpectResponseFrom,
                           &HeFrameExchangeManager::NormalAckTimeout,
                           this,
                           mpdu,
@@ -854,6 +847,7 @@
             NS_ASSERT(psdu);
             m_txTimer.Set(timerType,
                           timeout,
+                          staExpectResponseFrom,
                           &HeFrameExchangeManager::BlockAckTimeout,
                           this,
                           psdu,
@@ -862,25 +856,26 @@
         case WifiTxTimer::WAIT_BLOCK_ACKS_IN_TB_PPDU:
             m_txTimer.Set(timerType,
                           timeout,
+                          staExpectResponseFrom,
                           &HeFrameExchangeManager::BlockAcksInTbPpduTimeout,
                           this,
                           &m_psduMap,
-                          &m_staExpectTbPpduFrom,
-                          m_staExpectTbPpduFrom.size());
+                          staExpectResponseFrom.size());
             break;
         case WifiTxTimer::WAIT_TB_PPDU_AFTER_BASIC_TF:
         case WifiTxTimer::WAIT_QOS_NULL_AFTER_BSRP_TF:
             m_txTimer.Set(timerType,
                           timeout,
+                          staExpectResponseFrom,
                           &HeFrameExchangeManager::TbPpduTimeout,
                           this,
                           &m_psduMap,
-                          &m_staExpectTbPpduFrom,
-                          m_staExpectTbPpduFrom.size());
+                          staExpectResponseFrom.size());
             break;
         case WifiTxTimer::WAIT_BLOCK_ACK_AFTER_TB_PPDU:
             m_txTimer.Set(timerType,
                           timeout,
+                          staExpectResponseFrom,
                           &HeFrameExchangeManager::BlockAckAfterTbPpduTimeout,
                           this,
                           m_psduMap.begin()->second,
@@ -932,6 +927,8 @@
         FinalizeMacHeader(psdu);
         NotifyTxToEdca(psdu);
     }
+    m_allowedWidth = std::min(m_allowedWidth, txVector.GetChannelWidth());
+
     if (psduMap.size() > 1 || psduMap.begin()->second->IsAggregate() ||
         psduMap.begin()->second->IsSingle())
     {
@@ -1002,8 +999,7 @@
 
     if (protection->method == WifiProtection::MU_RTS_CTS)
     {
-        WifiMuRtsCtsProtection* muRtsCtsProtection =
-            static_cast<WifiMuRtsCtsProtection*>(protection);
+        auto muRtsCtsProtection = static_cast<WifiMuRtsCtsProtection*>(protection);
 
         // Get the TXVECTOR used by one station to send the CTS response. This is used
         // to compute the TX duration, so it does not matter which station we choose
@@ -1037,8 +1033,7 @@
      */
     if (acknowledgment->method == WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE)
     {
-        WifiDlMuBarBaSequence* dlMuBarBaAcknowledgment =
-            static_cast<WifiDlMuBarBaSequence*>(acknowledgment);
+        auto dlMuBarBaAcknowledgment = static_cast<WifiDlMuBarBaSequence*>(acknowledgment);
 
         Time duration = Seconds(0);
 
@@ -1085,7 +1080,7 @@
      */
     else if (acknowledgment->method == WifiAcknowledgment::DL_MU_TF_MU_BAR)
     {
-        WifiDlMuTfMuBar* dlMuTfMuBarAcknowledgment = static_cast<WifiDlMuTfMuBar*>(acknowledgment);
+        auto dlMuTfMuBarAcknowledgment = static_cast<WifiDlMuTfMuBar*>(acknowledgment);
 
         Time duration = Seconds(0);
 
@@ -1131,8 +1126,7 @@
      */
     else if (acknowledgment->method == WifiAcknowledgment::DL_MU_AGGREGATE_TF)
     {
-        WifiDlMuAggregateTf* dlMuAggrTfAcknowledgment =
-            static_cast<WifiDlMuAggregateTf*>(acknowledgment);
+        auto dlMuAggrTfAcknowledgment = static_cast<WifiDlMuAggregateTf*>(acknowledgment);
 
         Time duration = Seconds(0);
 
@@ -1166,7 +1160,7 @@
      */
     else if (acknowledgment->method == WifiAcknowledgment::UL_MU_MULTI_STA_BA)
     {
-        WifiUlMuMultiStaBa* ulMuMultiStaBa = static_cast<WifiUlMuMultiStaBa*>(acknowledgment);
+        auto ulMuMultiStaBa = static_cast<WifiUlMuMultiStaBa*>(acknowledgment);
 
         Time duration = m_phy->CalculateTxDuration(GetBlockAckSize(ulMuMultiStaBa->baType),
                                                    ulMuMultiStaBa->multiStaBaTxVector,
@@ -1250,8 +1244,7 @@
         txParams.m_acknowledgment->method == WifiAcknowledgment::DL_MU_AGGREGATE_TF)
     {
         // we need to account for the size of the aggregated MU-BAR Trigger Frame
-        WifiDlMuAggregateTf* acknowledgment =
-            static_cast<WifiDlMuAggregateTf*>(txParams.m_acknowledgment.get());
+        auto acknowledgment = static_cast<WifiDlMuAggregateTf*>(txParams.m_acknowledgment.get());
 
         const auto& info = acknowledgment->stationsReplyingWithBlockAck.find(receiver);
         NS_ASSERT(info != acknowledgment->stationsReplyingWithBlockAck.end());
@@ -1271,20 +1264,19 @@
 }
 
 void
-HeFrameExchangeManager::TbPpduTimeout(WifiPsduMap* psduMap,
-                                      const std::set<Mac48Address>* staMissedTbPpduFrom,
-                                      std::size_t nSolicitedStations)
+HeFrameExchangeManager::TbPpduTimeout(WifiPsduMap* psduMap, std::size_t nSolicitedStations)
 {
-    NS_LOG_FUNCTION(this << psduMap << staMissedTbPpduFrom->size() << nSolicitedStations);
+    const auto& staMissedTbPpduFrom = m_txTimer.GetStasExpectedToRespond();
+    NS_LOG_FUNCTION(this << psduMap << staMissedTbPpduFrom.size() << nSolicitedStations);
 
     NS_ASSERT(psduMap);
     NS_ASSERT(IsTrigger(*psduMap));
 
     // This method is called if some station(s) did not send a TB PPDU
-    NS_ASSERT(!staMissedTbPpduFrom->empty());
+    NS_ASSERT(!staMissedTbPpduFrom.empty());
     NS_ASSERT(m_edca);
 
-    if (staMissedTbPpduFrom->size() == nSolicitedStations)
+    if (staMissedTbPpduFrom.size() == nSolicitedStations)
     {
         // no station replied, the transmission failed
         m_edca->UpdateFailedCw(m_linkId);
@@ -1301,10 +1293,8 @@
 }
 
 void
-HeFrameExchangeManager::BlockAcksInTbPpduTimeout(
-    WifiPsduMap* psduMap,
-    const std::set<Mac48Address>* staMissedBlockAckFrom,
-    std::size_t nSolicitedStations)
+HeFrameExchangeManager::BlockAcksInTbPpduTimeout(WifiPsduMap* psduMap,
+                                                 std::size_t nSolicitedStations)
 {
     NS_LOG_FUNCTION(this << psduMap << nSolicitedStations);
 
@@ -1314,11 +1304,12 @@
                m_txParams.m_acknowledgment->method == WifiAcknowledgment::DL_MU_TF_MU_BAR));
 
     // This method is called if some station(s) did not send a BlockAck frame in a TB PPDU
-    NS_ASSERT(!staMissedBlockAckFrom->empty());
+    const auto& staMissedBlockAckFrom = m_txTimer.GetStasExpectedToRespond();
+    NS_ASSERT(!staMissedBlockAckFrom.empty());
 
     bool resetCw;
 
-    if (staMissedBlockAckFrom->size() == nSolicitedStations)
+    if (staMissedBlockAckFrom.size() == nSolicitedStations)
     {
         // no station replied, the transmission failed
         // call ReportDataFailed to increase SRC/LRC
@@ -1334,11 +1325,10 @@
     if (m_triggerFrame)
     {
         // this is strictly needed for DL_MU_TF_MU_BAR only
-        DequeueMpdu(m_triggerFrame);
         m_triggerFrame = nullptr;
     }
 
-    for (const auto& sta : *staMissedBlockAckFrom)
+    for (const auto& sta : staMissedBlockAckFrom)
     {
         Ptr<WifiPsdu> psdu = GetPsduTo(sta, *psduMap);
         NS_ASSERT(psdu);
@@ -1362,7 +1352,7 @@
         m_edca->UpdateFailedCw(m_linkId);
     }
 
-    if (staMissedBlockAckFrom->size() == nSolicitedStations)
+    if (staMissedBlockAckFrom.size() == nSolicitedStations)
     {
         // no station replied, the transmission failed
         TransmissionFailed();
@@ -1508,7 +1498,7 @@
         trigger.GetApTxPower() -
         static_cast<int8_t>(
             *optRssi); // cast RSSI to be on equal footing with AP Tx power information
-    double reqTxPowerDbm = static_cast<double>(userInfoIt->GetUlTargetRssi() + pathLossDb);
+    auto reqTxPowerDbm = static_cast<double>(userInfoIt->GetUlTargetRssi() + pathLossDb);
 
     // Convert the transmit power to a power level
     uint8_t numPowerLevels = m_phy->GetNTxPower();
@@ -1561,7 +1551,7 @@
         NS_ASSERT(itAidAddr != staList.end());
         auto optRssi = GetMostRecentRssi(itAidAddr->second);
         NS_ASSERT(optRssi);
-        int8_t rssi = static_cast<int8_t>(*optRssi);
+        auto rssi = static_cast<int8_t>(*optRssi);
         rssi = (rssi >= -20)
                    ? -20
                    : ((rssi <= -110) ? -110 : rssi); // cap so as to keep within [-110; -20] dBm
@@ -1642,8 +1632,7 @@
     NS_ASSERT(m_apMac);
     NS_ASSERT(txParams.m_acknowledgment &&
               txParams.m_acknowledgment->method == WifiAcknowledgment::UL_MU_MULTI_STA_BA);
-    WifiUlMuMultiStaBa* acknowledgment =
-        static_cast<WifiUlMuMultiStaBa*>(txParams.m_acknowledgment.get());
+    auto acknowledgment = static_cast<WifiUlMuMultiStaBa*>(txParams.m_acknowledgment.get());
 
     NS_ASSERT(!acknowledgment->stationsReceivingMultiStaBa.empty());
 
@@ -2203,11 +2192,10 @@
         Mac48Address sender = hdr.GetAddr2();
         NS_ASSERT(m_txParams.m_acknowledgment &&
                   m_txParams.m_acknowledgment->method == WifiAcknowledgment::UL_MU_MULTI_STA_BA);
-        WifiUlMuMultiStaBa* acknowledgment =
-            static_cast<WifiUlMuMultiStaBa*>(m_txParams.m_acknowledgment.get());
+        auto acknowledgment = static_cast<WifiUlMuMultiStaBa*>(m_txParams.m_acknowledgment.get());
         std::size_t index = acknowledgment->baType.m_bitmapLen.size();
 
-        if (m_staExpectTbPpduFrom.find(sender) == m_staExpectTbPpduFrom.end())
+        if (m_txTimer.GetStasExpectedToRespond().count(sender) == 0)
         {
             NS_LOG_WARN("Received a TB PPDU from an unexpected station: " << sender);
             return;
@@ -2268,9 +2256,9 @@
         }
 
         // remove the sender from the set of stations that are expected to send a TB PPDU
-        m_staExpectTbPpduFrom.erase(sender);
+        m_txTimer.GotResponseFrom(sender);
 
-        if (m_staExpectTbPpduFrom.empty())
+        if (m_txTimer.GetStasExpectedToRespond().empty())
         {
             // we do not expect any other BlockAck frame
             m_txTimer.Cancel();
@@ -2296,7 +2284,7 @@
     {
         const auto& sender = hdr.GetAddr2();
 
-        if (m_staExpectTbPpduFrom.find(sender) == m_staExpectTbPpduFrom.end())
+        if (m_txTimer.GetStasExpectedToRespond().count(sender) == 0)
         {
             NS_LOG_WARN("Received a TB PPDU from an unexpected station: " << sender);
             return;
@@ -2310,9 +2298,9 @@
         NS_LOG_DEBUG("Received a QoS Null frame in a TB PPDU from " << sender);
 
         // remove the sender from the set of stations that are expected to send a TB PPDU
-        m_staExpectTbPpduFrom.erase(sender);
+        m_txTimer.GotResponseFrom(sender);
 
-        if (m_staExpectTbPpduFrom.empty())
+        if (m_txTimer.GetStasExpectedToRespond().empty())
         {
             // we do not expect any other response
             m_txTimer.Cancel();
@@ -2375,7 +2363,7 @@
             NS_ASSERT(m_txParams.m_acknowledgment->method ==
                       WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE);
 
-            WifiDlMuBarBaSequence* acknowledgment =
+            auto acknowledgment =
                 static_cast<WifiDlMuBarBaSequence*>(m_txParams.m_acknowledgment.get());
             NS_ASSERT(acknowledgment->stationsReplyingWithNormalAck.size() == 1);
             NS_ASSERT(m_apMac);
@@ -2427,13 +2415,15 @@
                                                                m_txParams.m_txVector);
 
             // remove the sender from the set of stations that are expected to send a BlockAck
-            if (m_staExpectTbPpduFrom.erase(sender) == 0)
+            if (m_txTimer.GetStasExpectedToRespond().count(sender) == 0)
             {
                 NS_LOG_WARN("Received a BlockAck from an unexpected stations: " << sender);
                 return;
             }
 
-            if (m_staExpectTbPpduFrom.empty())
+            m_txTimer.GotResponseFrom(sender);
+
+            if (m_txTimer.GetStasExpectedToRespond().empty())
             {
                 // we do not expect any other BlockAck frame
                 m_txTimer.Cancel();
@@ -2441,7 +2431,6 @@
                 if (m_triggerFrame)
                 {
                     // this is strictly needed for DL_MU_TF_MU_BAR only
-                    DequeueMpdu(m_triggerFrame);
                     m_triggerFrame = nullptr;
                 }
 
@@ -2676,11 +2665,10 @@
         Mac48Address sender = psdu->GetAddr2();
         NS_ASSERT(m_txParams.m_acknowledgment &&
                   m_txParams.m_acknowledgment->method == WifiAcknowledgment::UL_MU_MULTI_STA_BA);
-        WifiUlMuMultiStaBa* acknowledgment =
-            static_cast<WifiUlMuMultiStaBa*>(m_txParams.m_acknowledgment.get());
+        auto acknowledgment = static_cast<WifiUlMuMultiStaBa*>(m_txParams.m_acknowledgment.get());
         std::size_t index = acknowledgment->baType.m_bitmapLen.size();
 
-        if (m_staExpectTbPpduFrom.find(sender) == m_staExpectTbPpduFrom.end())
+        if (m_txTimer.GetStasExpectedToRespond().count(sender) == 0)
         {
             NS_LOG_WARN("Received a TB PPDU from an unexpected station: " << sender);
             return;
@@ -2726,9 +2714,9 @@
         }
 
         // remove the sender from the set of stations that are expected to send a TB PPDU
-        m_staExpectTbPpduFrom.erase(sender);
+        m_txTimer.GotResponseFrom(sender);
 
-        if (m_staExpectTbPpduFrom.empty())
+        if (m_txTimer.GetStasExpectedToRespond().empty())
         {
             // we do not expect any other BlockAck frame
             m_txTimer.Cancel();
@@ -2753,7 +2741,7 @@
     {
         Mac48Address sender = psdu->GetAddr2();
 
-        if (m_staExpectTbPpduFrom.find(sender) == m_staExpectTbPpduFrom.end())
+        if (m_txTimer.GetStasExpectedToRespond().count(sender) == 0)
         {
             NS_LOG_WARN("Received a TB PPDU from an unexpected station: " << sender);
             return;
@@ -2769,9 +2757,9 @@
         NS_LOG_DEBUG("Received QoS Null frames in a TB PPDU from " << sender);
 
         // remove the sender from the set of stations that are expected to send a TB PPDU
-        m_staExpectTbPpduFrom.erase(sender);
+        m_txTimer.GotResponseFrom(sender);
 
-        if (m_staExpectTbPpduFrom.empty())
+        if (m_txTimer.GetStasExpectedToRespond().empty())
         {
             // we do not expect any other response
             m_txTimer.Cancel();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/he/he-frame-exchange-manager.h ns-3.40/src/wifi/model/he/he-frame-exchange-manager.h
--- ns-3.39/src/wifi/model/he/he-frame-exchange-manager.h	2023-07-05 14:23:48.113428400 -0700
+++ ns-3.40/src/wifi/model/he/he-frame-exchange-manager.h	2023-09-27 13:30:37.906839800 -0700
@@ -78,7 +78,6 @@
     uint16_t GetSupportedBaBufferSize() const override;
     bool StartFrameExchange(Ptr<QosTxop> edca, Time availableTime, bool initialFrame) override;
     void SetWifiMac(const Ptr<WifiMac> mac) override;
-    void SetWifiPhy(const Ptr<WifiPhy> phy) override;
     void CalculateAcknowledgmentTime(WifiAcknowledgment* acknowledgment) const override;
     void CalculateProtectionTime(WifiProtection* protection) const override;
     void SetTxopHolder(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector) override;
@@ -144,7 +143,7 @@
   protected:
     void DoDispose() override;
     void Reset() override;
-
+    void RxStartIndication(WifiTxVector txVector, Time psduDuration) override;
     void ReceiveMpdu(Ptr<const WifiMpdu> mpdu,
                      RxSignalInfo rxSignalInfo,
                      const WifiTxVector& txVector,
@@ -157,7 +156,6 @@
     Time GetTxDuration(uint32_t ppduPayloadSize,
                        Mac48Address receiver,
                        const WifiTxParameters& txParams) const override;
-    bool SendMpduFromBaManager(Ptr<WifiMpdu> mpdu, Time availableTime, bool initialFrame) override;
     void NormalAckTimeout(Ptr<WifiMpdu> mpdu, const WifiTxVector& txVector) override;
     void BlockAckTimeout(Ptr<WifiPsdu> psdu, const WifiTxVector& txVector) override;
     void CtsTimeout(Ptr<WifiMpdu> rts, const WifiTxVector& txVector) override;
@@ -165,6 +163,7 @@
     void NavResetTimeout() override;
     void StartProtection(const WifiTxParameters& txParams) override;
     void ProtectionCompleted() override;
+    void TransmissionSucceeded() override;
 
     /**
      * Clear the TXOP holder if the intra-BSS NAV counted down to zero (includes the case
@@ -264,12 +263,9 @@
      * expected BlockAck frames were received.
      *
      * \param psduMap a pointer to PSDU map transmitted in a DL MU PPDU
-     * \param staMissedBlockAckFrom set of stations we missed a BlockAck frame from
      * \param nSolicitedStations the number of stations solicited to send a TB PPDU
      */
-    virtual void BlockAcksInTbPpduTimeout(WifiPsduMap* psduMap,
-                                          const std::set<Mac48Address>* staMissedBlockAckFrom,
-                                          std::size_t nSolicitedStations);
+    virtual void BlockAcksInTbPpduTimeout(WifiPsduMap* psduMap, std::size_t nSolicitedStations);
 
     /**
      * Take the necessary actions after that some TB PPDUs are missing in
@@ -277,12 +273,9 @@
      * expected TB PPDUs were received.
      *
      * \param psduMap a pointer to PSDU map transmitted in a DL MU PPDU
-     * \param staMissedTbPpduFrom set of stations we missed a TB PPDU from
      * \param nSolicitedStations the number of stations solicited to send a TB PPDU
      */
-    virtual void TbPpduTimeout(WifiPsduMap* psduMap,
-                               const std::set<Mac48Address>* staMissedTbPpduFrom,
-                               std::size_t nSolicitedStations);
+    virtual void TbPpduTimeout(WifiPsduMap* psduMap, std::size_t nSolicitedStations);
 
     /**
      * Take the necessary actions after that a Block Ack is missing after a
@@ -381,14 +374,13 @@
                              Time durationId,
                              double snr);
 
-    WifiPsduMap m_psduMap;                        //!< the A-MPDU being transmitted
-    WifiTxParameters m_txParams;                  //!< the TX parameters for the current PPDU
-    Ptr<MultiUserScheduler> m_muScheduler;        //!< Multi-user Scheduler (HE APs only)
-    Ptr<WifiMpdu> m_triggerFrame;                 //!< Trigger Frame being sent
-    std::set<Mac48Address> m_staExpectTbPpduFrom; //!< set of stations expected to send a TB PPDU
-    EventId m_multiStaBaEvent;                    //!< Sending a Multi-STA BlockAck event
-    MuSnrTag m_muSnrTag;                          //!< Tag to attach to Multi-STA BlockAck frames
-    bool m_triggerFrameInAmpdu; //!< True if the received A-MPDU contains an MU-BAR
+    WifiPsduMap m_psduMap;                 //!< the A-MPDU being transmitted
+    WifiTxParameters m_txParams;           //!< the TX parameters for the current PPDU
+    Ptr<MultiUserScheduler> m_muScheduler; //!< Multi-user Scheduler (HE APs only)
+    Ptr<WifiMpdu> m_triggerFrame;          //!< Trigger Frame being sent
+    EventId m_multiStaBaEvent;             //!< Sending a Multi-STA BlockAck event
+    MuSnrTag m_muSnrTag;                   //!< Tag to attach to Multi-STA BlockAck frames
+    bool m_triggerFrameInAmpdu;            //!< True if the received A-MPDU contains an MU-BAR
 };
 
 } // namespace ns3
